# -*- coding: utf-8 -*-
"""
Tirage au sort d'un élève dans une liste.
"""

# la liste des élèves est dans un autre fichier.
# from eleves import eleves
# grâce à cette commande, on a accès à la liste eleves du module eleves
# ceci est utile pour tester vos fonctions.

import random


def tire_au_hasard(liste):
    """
    Tire au hasard un élève dans la liste.
    Retourne le nom de l'élève choisi (et PAS affiche l'élève choisi).
    """



def choisi_eleve(liste, passages):
    """
    Même chose que la fonction précédente, mais la liste
    passages représente le nombre de fois où l'élève en question
    a déjà été choisi. passages est de même longueur que
    eleves et est remplie d'entiers.

    Cette fonctions met à jour les données de passages (c'est à dire ajoute 1 au bon endroit),
    puis retourne le nom de l'élève choisi.
    Pour l'instant on ne tient pas compte de passages pour choisir.
    """



def remise_a_zero(passages):
    """
    Remet tous les éléments de la liste donnée à la valeur 0.
    Retourne la liste en question.
    Attention, on demande bien ici de modifier la liste passée en paramètre.

    >>> remise_a_zero([1,2,3])
    [0, 0, 0]
    >>> l = [1, 2]; remise_a_zero(l); l == [0, 0]
    [0, 0]
    True
    """



def choix_sans_remise(liste, passages):
    """
    Choisi un elève au hasard parmi ceux qui n'ont pas encore
    été choisi de cette manière.
    Si tous les élèves ont été choisi, on remet passages à 0.

    Comme la fonction précédente, met passages à jour, et retourne le nom de l'élève choisi.
    """



def moyenne(L):
    """
    Calcule et retourne la moyenne de la liste non vide L.

    >>> moyenne([2,4,6])
    4
    """



def sommes_cumulees(L):
    """
    Calcule la liste des sommes cumulées de L.
    Cette liste est [L[0], L[0] + L[1], L[0] + L[1] + L[2], ...]
    Retourne la liste des sommes cumulées sans modifier L.

    >>> sommes_cumulees([1,2,3,4])
    [1, 3, 6, 10]
    """



def choix_pondere(liste, passages):
    """
    Choix d'un élève avec une probabilité non uniforme.
    Un élève qui est passé une fois de moins en moyenne que les autres
    a deux fois plus de chances d'être choisi, et inversement un élève qui
    est passé en moyenne une fois de plus a deux fois moins de chances d'être choisi.
    """


if __name__ == "__main__":
    import doctest
    doctest.testmod()
